%global debug_package %{nil}

%global official_version 2.10.0

Name:      ocsinventory-agent
Summary:   Open Computer and Software Inventory Next Generation client

Version:   2.10.0
Release:    1%{?dist}

Source0:   https://github.com/OCSInventory-NG/UnixAgent/releases/download/v%{official_version}/Ocsinventory-Unix-Agent-%{official_version}.tar.gz

Source11:   %{name}.README

License:   GPLv2+
URL:       http://www.ocsinventory-ng.org/

BuildRequires: coreutils
BuildRequires: findutils
BuildRequires: make
BuildRequires: perl-interpreter
BuildRequires: perl-generators
BuildRequires: perl(Config)
BuildRequires: perl(English)
BuildRequires: perl(Getopt::Long)
BuildRequires: perl(inc::Module::Install)
BuildRequires: perl(Module::Install::Metadata)
BuildRequires: perl(Module::Install::Scripts)
BuildRequires: perl(Module::Install::WriteAll)
BuildRequires: perl(strict)
BuildRequires: sed
BuildRequires: systemd-rpm-macros
Requires(post): systemd

Requires: perl-Ocsinventory-Agent = %{version}-%{release}
%ifarch %{ix86} x86_64 ia64
Requires:  dmidecode
%endif

%ifarch %{ix86} x86_64
Requires:  libx86
%endif

Requires:  logrotate

Provides:  ocsinventory-client = %{version}-%{release}

%{?perl_default_filter}

%description
Open Computer and Software Inventory Next Generation is an application
designed to help a network or system administrator keep track of computer
configuration and software installed on the network. 

It also allows deploying software, commands or files on Windows and
Linux client computers.

%{name} provides the client for Linux (Unified Unix Agent).


%description -l fr
Open Computer and Software Inventory Next Generation est une application
destinée à aider l'administrateur système ou réseau à garder un oeil sur
la configuration des machines du réseau et sur les logiciels qui y sont
installés. 

Elle autorise aussi la télédiffusion (ou déploiement) de logiciels, 
de commandes ou de fichiers sur les clients Windows ou Linux.

%{name} fournit le client pour Linux (Agent Unix Unifié)


%package -n perl-Ocsinventory-Agent
Summary:   Libraries %{name}
BuildArch: noarch

Requires:  perl(Data::UUID)
Requires:  perl(Digest::MD5)
Requires:  perl(File::Temp)
Requires:  perl(HTTP::Request)
Requires:  perl(LWP) > 6
Requires:  perl(LWP::Protocol)
Requires:  perl(LWP::Protocol::http)
Requires:  perl(LWP::Protocol::https)
Requires:  perl(Net::IP)
Requires:  perl(Net::Netmask)
Requires:  perl(Net::SNMP)
Requires:  perl(Net::SSLeay)
Requires:  perl(XML::Simple)
Requires: monitor-edid
Requires: net-tools
Requires: pciutils
Requires: smartmontools
Requires: which
Recommends: perl(Net::Cups)
Recommends: perl(Net::Ping)
Recommends: perl(Parse::EDID)
Recommends: perl(Proc::Daemon)
Recommends: perl(Proc::PID::File)
Recommends: ipmitool
Suggests: nmap
Suggests: perl(Nmap::Parser)

Conflicts: %{name} < %{version}

%description  -n perl-Ocsinventory-Agent
Perl libraries for %{name}

%prep
%setup -q -n Ocsinventory-Unix-Agent-%{version}
rm -f lib/Ocsinventory/Agent/Network.pm.orig

sed -e 's/\r//' -i snmp/mibs/local/6876.xml

rm -rf ./inc
if [[ -e MANIFEST ]]; then
  perl -MConfig -i -ne 'print $_ unless m{^inc/}' MANIFEST
fi

cat <<EOF >%{name}.conf

PATH=/sbin:/bin:/usr/sbin:/usr/bin

%if 0%{?ocsserver:1}
OCSMODE[0]=cron

OCSSERVER[0]=%{ocsserver}

%else
OCSMODE[0]=none

%endif

OCSPAUSE[0]=100

OCSTAG[0]=%{?ocstag}

EOF

cat <<EOF >%{name}.cfg

local = %{_localstatedir}/lib/%{name}


logger = Stderr
logfile = %{_localstatedir}/log/%{name}/%{name}.log
EOF

cp %{SOURCE11} README.RPM


%build
/usr/bin/perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}" NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}
rm run-postinst

%install
%{make_install}
find %{buildroot} -type f -name '*.bs' -size 0 -delete

mv %{buildroot}%{_bindir} %{buildroot}%{_sbindir}

mkdir -p %{buildroot}%{_localstatedir}/{log,lib}/%{name}
mkdir -p %{buildroot}%{_sysconfdir}/{logrotate.d,sysconfig,ocsinventory/softwares}

mkdir %{buildroot}%{_localstatedir}/lib/%{name}/download
cp -pr snmp %{buildroot}%{_localstatedir}/lib/%{name}/snmp

install -pm 644 %{name}.conf %{buildroot}%{_sysconfdir}/sysconfig/%{name}

mkdir -p %{buildroot}/%{_libexecdir}/%{name}
sed -e 's;/etc/;%{_sysconfdir}/;' \
    -e 's;/var/;%{_localstatedir}/;' \
    -e 's;/usr/sbin/;%{_sbindir}/;' \
    contrib/cron/ocsinventory-agent.cron > %{buildroot}%{_libexecdir}/%{name}/ocsinventory-agent.cron
cp contrib/cron/ocsinventory-agent.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

mkdir -p %{buildroot}/%{_unitdir}
cp contrib/cron/systemd/* %{buildroot}/%{_unitdir}/

install -m 644 %{name}.cfg %{buildroot}/%{_sysconfdir}/ocsinventory/%{name}.cfg
install -m 644 etc/ocsinventory-agent/modules.conf %{buildroot}/%{_sysconfdir}/ocsinventory/modules.conf

rm -rf %{buildroot}%{perl_vendorlib}/Ocsinventory/Agent/Backend/OS/Win32*

rm -f %{buildroot}%{perl_vendorarch}/auto/Ocsinventory/Unix/Agent/.packlist
rm -f %{buildroot}%{perl_vendorarch}/../perllocal.pod

rm %{buildroot}%{perl_vendorlib}/Ocsinventory/Unix/postinst.pl

rm %{buildroot}%{_sbindir}/ipdiscover

find %{buildroot} -type f -exec chmod 644 {} \;
find %{buildroot} -type f -name .DS_Store -exec rm {} \;
find %{buildroot} -type f -name ._.DS_Store -exec rm {} \;

%post

%systemd_post ocsinventory-agent-onboot.timer

%systemd_post ocsinventory-agent-hourly.timer

%systemd_post ocsinventory-agent-daily.timer

%files
%defattr(644,root,root,755)
%attr(0755, root, root) %{_sbindir}/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{_libexecdir}/%{name}/
%attr(0755, root, root) %{_libexecdir}/%{name}/ocsinventory-agent.cron
%dir %{_localstatedir}/log/%{name}
%{_mandir}/man1/%{name}*
%{_unitdir}/*

%files -n perl-Ocsinventory-Agent
%defattr(644,root,root,755)
%doc AUTHORS Changes README.md THANKS README.RPM
%doc etc/ocsinventory-agent/softwares/example.sh
%license LICENSE
%config(noreplace) %{_sysconfdir}/ocsinventory/%{name}.cfg
%config(noreplace) %{_sysconfdir}/ocsinventory/modules.conf
%{perl_vendorlib}/Ocsinventory
%attr(0755, root, root) %{perl_vendorlib}/Ocsinventory/Agent.pm
%{_mandir}/man3/Ocs*
%dir %{_localstatedir}/lib/%{name}
%{_localstatedir}/lib/%{name}/download
%{_localstatedir}/lib/%{name}/snmp
%dir %{_sysconfdir}/ocsinventory
%dir %{_sysconfdir}/ocsinventory/softwares


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.10.0-1
- initial build
